Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/par_fabm.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/par_fabm.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/par_fabm.F90	(revision 10622)
@@ -12,21 +12,28 @@
 
    ! Variables needed for OBS/ASM
-   INTEGER, PUBLIC :: jp_fabm_chl1, jp_fabm_chl2, &
-                      jp_fabm_chl3, jp_fabm_chl4, &
-                      jp_fabm_p1c,  jp_fabm_p1n,  &
-                      jp_fabm_p1p,  jp_fabm_p1s,  &
-                      jp_fabm_p2c,  jp_fabm_p2n,  &
-                      jp_fabm_p2p,  jp_fabm_p3c,  &
-                      jp_fabm_p3n,  jp_fabm_p3p,  &
-                      jp_fabm_p4c,  jp_fabm_p4n,  &
-                      jp_fabm_p4p,  jp_fabm_z4c,  &
-                      jp_fabm_z5c,  jp_fabm_z5n,  &
-                      jp_fabm_z5p,  jp_fabm_z6c,  &
-                      jp_fabm_z6n,  jp_fabm_z6p,  &
-                      jp_fabm_n1p,  jp_fabm_n3n,  &
-                      jp_fabm_n4n,  jp_fabm_n5s,  &
-                      jp_fabm_o2o,  jp_fabm_o3c,  &
-                      jp_fabm_o3a,  jp_fabm_o3ph, &
-                      jp_fabm_o3pc
+   INTEGER, PUBLIC :: jp_fabm_chl1,  jp_fabm_chl2, &
+                      jp_fabm_chl3,  jp_fabm_chl4, &
+                      jp_fabm_p1c,   jp_fabm_p1n,  &
+                      jp_fabm_p1p,   jp_fabm_p1s,  &
+                      jp_fabm_p2c,   jp_fabm_p2n,  &
+                      jp_fabm_p2p,   jp_fabm_p3c,  &
+                      jp_fabm_p3n,   jp_fabm_p3p,  &
+                      jp_fabm_p4c,   jp_fabm_p4n,  &
+                      jp_fabm_p4p,   jp_fabm_z4c,  &
+                      jp_fabm_z5c,   jp_fabm_z5n,  &
+                      jp_fabm_z5p,   jp_fabm_z6c,  &
+                      jp_fabm_z6n,   jp_fabm_z6p,  &
+                      jp_fabm_n1p,   jp_fabm_n3n,  &
+                      jp_fabm_n4n,   jp_fabm_n5s,  &
+                      jp_fabm_o2o,   jp_fabm_o3c,  &
+                      jp_fabm_o3ta,  jp_fabm_o3ba, &
+                      jp_fabm_o3pc,  jp_fabm_o3ph, &
+                      jp_fabm_r4n,   jp_fabm_r4c,  &
+                      jp_fabm_r4p,   jp_fabm_r6n,  &
+                      jp_fabm_r6c,   jp_fabm_r6p,  &
+                      jp_fabm_r6s,   jp_fabm_r8n,  &
+                      jp_fabm_r8c,   jp_fabm_r8p,  &
+                      jp_fabm_r8s,                 &
+                      jp_fabm_pgrow, jp_fabm_ploss
 
 #if defined key_fabm
Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/trcini_fabm.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/trcini_fabm.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/trcini_fabm.F90	(revision 10622)
@@ -105,9 +105,28 @@
       jp_fabm_o2o  = fabm_state_index( 'O2_o' )
       jp_fabm_o3c  = fabm_state_index( 'O3_c' )
-      jp_fabm_o3a  = fabm_state_index( 'O3_bioalk' )
+      jp_fabm_o3ba = fabm_state_index( 'O3_bioalk' )
+      jp_fabm_r4n  = fabm_state_index( 'R4_n' )
+      jp_fabm_r4c  = fabm_state_index( 'R4_c' )
+      jp_fabm_r4p  = fabm_state_index( 'R4_p' )
+      jp_fabm_r6n  = fabm_state_index( 'R6_n' )
+      jp_fabm_r6c  = fabm_state_index( 'R6_c' )
+      jp_fabm_r6p  = fabm_state_index( 'R6_p' )
+      jp_fabm_r6s  = fabm_state_index( 'R6_s' )
+      jp_fabm_r8n  = fabm_state_index( 'R8_n' )
+      jp_fabm_r8c  = fabm_state_index( 'R8_c' )
+      jp_fabm_r8p  = fabm_state_index( 'R8_p' )
+      jp_fabm_r8s  = fabm_state_index( 'R8_s' )
 
       ! Get indexes for select diagnostic variables
-      jp_fabm_o3ph = fabm_diag_index( 'O3_pH' )
-      jp_fabm_o3pc = fabm_diag_index( 'O3_pCO2' )
+      jp_fabm_o3ta  = fabm_diag_index( 'O3_TA' )
+      jp_fabm_o3ph  = fabm_diag_index( 'O3_pH' )
+      jp_fabm_o3pc  = fabm_diag_index( 'O3_pCO2' )
+      jp_fabm_pgrow = fabm_diag_index( 'p_grow_sum_result' )
+      jp_fabm_ploss = fabm_diag_index( 'p_loss_sum_result' )
+      
+      MLD_MAX(:,:)   = 0.0
+      PGROW_AVG(:,:) = 0.0
+      PLOSS_AVG(:,:) = 0.0
+      PHYT_AVG(:,:)  = 0.0
 
       IF (lwp) THEN
@@ -445,5 +464,5 @@
       END DO
       IF (fabm_state_index == -1) THEN
-         CALL ctl_stop( 'Could not find '//TRIM(state_name)//' state variable' )
+         CALL ctl_warn( 'Could not find '//TRIM(state_name)//' state variable' )
       ELSE
          IF (lwp) WRITE(numout,*) 'Index for '//TRIM(state_name)//' is: ', fabm_state_index
@@ -477,5 +496,5 @@
       END DO
       IF (fabm_diag_index == -1) THEN
-         CALL ctl_stop( 'Could not find '//TRIM(diag_name)//' diagnostic' )
+         CALL ctl_warn( 'Could not find '//TRIM(diag_name)//' diagnostic' )
       ELSE
          IF (lwp) WRITE(numout,*) 'Index for '//TRIM(diag_name)//' is: ', fabm_diag_index
Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/trcsms_fabm.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/trcsms_fabm.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/FABM/trcsms_fabm.F90	(revision 10622)
@@ -33,4 +33,7 @@
    USE inputs_fabm
    USE vertical_movement_fabm
+   USE zdfmxl
+   USE asmbgc, ONLY: mld_choice_bgc
+   USE lbclnk
 
    !USE fldread         !  time interpolation
@@ -113,4 +116,6 @@
 
       CALL st2d_fabm_nxt( kt )
+      
+      CALL asmdiags_fabm( kt )
 
       IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrfabm )
@@ -130,4 +135,88 @@
 
    END SUBROUTINE trc_sms_fabm
+   
+   SUBROUTINE asmdiags_fabm( kt )
+      INTEGER, INTENT(IN) :: kt
+      INTEGER :: ji,jj,jk,jkmax
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: pgrow_3d, ploss_3d, zmld
+	   
+      IF (kt == nittrc000) THEN
+         MLD_MAX(:,:) = 0.0
+      ENDIF
+      PGROW_AVG(:,:) = 0.0
+      PLOSS_AVG(:,:) = 0.0
+      PHYT_AVG(:,:)  = 0.0
+	     
+      pgrow_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabm_pgrow)
+      ploss_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabm_ploss)
+      
+      SELECT CASE( mld_choice_bgc )
+      CASE ( 1 )                   ! Turbocline/mixing depth [W points]
+         zmld(:,:) = hmld(:,:)
+      CASE ( 2 )                   ! Density criterion (0.01 kg/m^3 change from 10m) [W points]
+         zmld(:,:) = hmlp(:,:)
+      CASE ( 3 )                   ! Kara MLD [Interpolated]
+#if defined key_karaml
+         IF ( ln_kara ) THEN
+            zmld(:,:) = hmld_kara(:,:)
+         ELSE
+            CALL ctl_stop( ' Kara mixed layer requested for BGC assimilation,', &
+               &           ' but ln_kara=.false.' )
+         ENDIF
+#else
+         CALL ctl_stop( ' Kara mixed layer requested for BGC assimilation,', &
+            &           ' but is not defined' )
+#endif
+      CASE ( 4 )                   ! Temperature criterion (0.2 K change from surface) [T points]
+         zmld(:,:) = hmld_tref(:,:)
+      CASE ( 5 )                   ! Density criterion (0.01 kg/m^3 change from 10m) [T points]
+         zmld(:,:) = hmlpt(:,:)
+      END SELECT
+	
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            !
+            jkmax = jpk-1
+            DO jk = jpk-1, 1, -1
+               IF ( ( zmld(ji,jj) >  gdepw_n(ji,jj,jk)   ) .AND. &
+                  & ( zmld(ji,jj) <= gdepw_n(ji,jj,jk+1) ) ) THEN
+                  zmld(ji,jj) = gdepw_n(ji,jj,jk+1)
+                  jkmax = jk
+               ENDIF
+            END DO
+            !
+            DO jk = 1, jkmax
+               PHYT_AVG(ji,jj) = PHYT_AVG(ji,jj) + &
+                  &              trn(ji,jj,jk,jp_fabm_p1n) + &
+                  &              trn(ji,jj,jk,jp_fabm_p2n) + &
+                  &              trn(ji,jj,jk,jp_fabm_p3n) + &
+                  &              trn(ji,jj,jk,jp_fabm_p4n)
+               IF ( pgrow_3d(ji,jj,jk) .GT. 0.0 ) THEN
+                  PGROW_AVG(ji,jj) = PGROW_AVG(ji,jj) + &
+                     &               pgrow_3d(ji,jj,jk)
+               ENDIF
+               IF ( ploss_3d(ji,jj,jk) .GT. 0.0 ) THEN
+                  PLOSS_AVG(ji,jj) = PLOSS_AVG(ji,jj) + &
+                     &               ploss_3d(ji,jj,jk)
+               ENDIF
+            END DO
+           
+            PHYT_AVG(ji,jj)  = PHYT_AVG(ji,jj)  / REAL(jkmax)
+            PGROW_AVG(ji,jj) = PGROW_AVG(ji,jj) / REAL(jkmax)
+            PLOSS_AVG(ji,jj) = PLOSS_AVG(ji,jj) / REAL(jkmax)
+	
+            IF ( zmld(ji,jj) .GT. MLD_MAX(ji,jj) ) THEN
+               MLD_MAX(ji,jj) = zmld(ji,jj)
+            ENDIF
+            !
+         END DO
+      END DO
+      
+      PHYT_AVG(:,:)  = PHYT_AVG(:,:)  * tmask(:,:,1)
+      PGROW_AVG(:,:) = PGROW_AVG(:,:) * tmask(:,:,1)
+      PLOSS_AVG(:,:) = PLOSS_AVG(:,:) * tmask(:,:,1)
+      MLD_MAX(:,:)   = MLD_MAX(:,:)   * tmask(:,:,1)
+	   
+   END SUBROUTINE asmdiags_fabm
 
    SUBROUTINE compute_fabm()
Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 10622)
@@ -225,4 +225,11 @@
 #endif
 
+#if defined key_fabm
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  PGROW_AVG  !: Phytoplankton growth for use in ASM code
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  PLOSS_AVG  !: Phytoplankton loss   for use in ASM code
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  PHYT_AVG   !: Phytoplankton        for use in ASM code
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  MLD_MAX    !: Maximum MLD          for use in ASM code
+#endif
+
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3.1 , NEMO Consortium (2010)
@@ -253,4 +260,6 @@
 ! FABM <<<+++
          &      ln_trc_sbc(jptra)     , ln_trc_cbc(jptra)     , ln_trc_obc(jptra)     ,       &
+         &      PGROW_AVG(jpi,jpj)    , PLOSS_AVG(jpi,jpj)    , PHYT_AVG(jpi,jpj)     ,       &
+         &      MLD_MAX(jpi,jpj)      ,                                                       &
 #endif
 #if defined key_bdy
